local LDB

local menu = {}

local parent = CreateFrame('Frame')

 -- Get a reference to the lib
local LibQTip = LibStub('LibQTip-1.0')
local tooltip = nil


local function UpdateDisplay()
	if lastmountIndex ~= nil then
		LDB.text = lastmountText
		LDB.icon = lastmountIcon
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", lastmountIndex) -- check to see if a new companion was learned and moved the index of the last
		if creatureName ~= lastmountText then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
			if creatureName == lastmountText then
				lastmountIndex = i
			end
			end
		end
	end
	
	if favmount1index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", favmount1index)
		if creatureName ~= favmount1name then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
			if creatureName == favmount1name then
				favmount1index = i
			end
			end
		end
	end
	if favmount2index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", favmount2index)
		if creatureName ~= favmount2name then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
			if creatureName == favmount2name then
				favmount2index = i
			end
			end
		end
	end
	if favmount3index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", favmount3index)
		if creatureName ~= favmount3name then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
			if creatureName == favmount3name then
				favmount3index = i
			end
			end
		end
	end
	
	for i = 1, GetNumCompanions("MOUNT") do
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		if issummoned then
			LDB.text = creatureName
			LDB.icon = icon
			lastmountIcon = icon
			lastmountIndex = i
			lastmountSpell = creatureSpellID
			lastmountText = creatureName
			return
		end
		if lastmountSpell ~= nil and lastmountText ~= nil then
		local isUsable, notEnoughMana = IsUsableSpell(lastmountSpell)
			if isUsable then
				LDB.text = lastmountText
			else
				LDB.text = string.format('|cff848484%s|r', lastmountText)
			end
		end
	end
end

local function ModifiedClick(button, i)	
local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
	if IsShiftKeyDown() then
		PickupCompanion("MOUNT", i)
	elseif IsAltKeyDown()and not IsControlKeyDown()  then
		favmount1index = i
		favmount1name = creatureName
		favmount1icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 1.", creatureName))
	elseif IsControlKeyDown() and not IsAltKeyDown() then
		favmount2index = i
		favmount2name = creatureName
		favmount2icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 2.", creatureName))
	elseif IsControlKeyDown() and IsAltKeyDown() then
		favmount3index = i
		favmount3name = creatureName
		favmount3icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 3.", creatureName))
	else
		CallCompanion("MOUNT", i)
	end
	LibQTip:Release(tooltip)
	tooltip = nil
end

local function OnTooltipShow(self)
	if tooltip and tooltip:IsShown() then
	LibQTip:Release(tooltip)
	tooltip = nil
	end
	self:AddLine('|cff00ffffBrokerMounts|r')
	self:AddLine("<Right Click> to open mount list")
	self:AddLine("<Left Click> to mount/dismount")
	self:AddLine("<Shift-Left Click> on mount to pick it up")
	--self:AddLine("<ALT-Click> mount to set as favorite 1")
	--self:AddLine("<CTRL-Click> mount to set as favorite 2")
	--self:AddLine("<CTRL-ALT-Click> mount to set as favorite 3")
	if GetNumCompanions("MOUNT") == 0 then
	self:AddLine("|cffff0000You have no mounts|r")
	else
	self:AddLine(string.format("|cff00ff00You have %s mounts|r", GetNumCompanions("MOUNT")))
	end
end



local function anchor_OnEnter(self)
   
   -- Acquire a tooltip with 1 columns, aligned to left
tooltip = LibQTip:Acquire("BrokerMountsTooltip", 1, "LEFT") 
self.tooltip = tooltip 
tooltip:EnableMouse(true)
tooltip:SetAutoHideDelay(1.5, self)
   -- Add an header filling only the first two columns
   --tooltip:AddHeader('|cff00ffffBrokerMounts|r') -- extra line offsets index
  
   -- Use smart anchoring code to anchor the tooltip to our frame
tooltip:SmartAnchorTo(self)
   
	for i = 1, GetNumCompanions("MOUNT") do
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		 -- Add an new line, using all columns
		if isUsable then
			if issummoned then
			tooltip:AddLine(format("|T%s:16|t |cff00ff00%s|r", icon, creatureName))
			tooltip:SetCellScript(i, 1, "OnMouseDown", ModifiedClick, i)
			else
			tooltip:AddLine(format("|T%s:16|t %s", icon, creatureName))
			tooltip:SetCellScript(i, 1, "OnMouseDown", ModifiedClick, i)
			end
		else
			tooltip:AddLine(format("|T%s:16|t |cff848484%s|r", icon, creatureName))
			--tooltip:SetCellScript(i, 1, "OnMouseDown", ModifiedClick, i)
		end
		
		
	end
   tooltip:UpdateScrolling(500)
   -- Show it
	if tooltip:IsShown() then
		LibQTip:Release(self.tooltip)
		self.tooltip = nil
		
	else
		tooltip:Show()
	end
end
 
local function anchor_OnLeave(self)
   
   -- Release the tooltip
   LibQTip:Release(self.tooltip)
   self.tooltip = nil
   
end
 
local function OnClick(self, button)
	if button == 'RightButton' then
		--ToggleDropDownMenu(1, nil, parent, self, 0, 0)
		anchor_OnEnter(self)
	end
	if button == 'LeftButton' then
		if IsMounted() then
			Dismount()
		elseif lastmountIndex ~= nil then
			CallCompanion("MOUNT", lastmountIndex)
		end
	end
end 
 
 -- Somewhere in the anchor initialization
parent:SetScript('OnEnter', anchor_OnEnter)
parent:SetScript('OnLeave', anchor_OnLeave)


--[[local function CreateMenu(self, level)
	menu = wipe(menu)
	local firstChar
	if 	GetNumCompanions("MOUNT") <= 20 then
	for i = 1, GetNumCompanions("MOUNT") do
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		menu.text = creatureName
		menu.icon = icon
		menu.colorCode = "|cffffffff"
		menu.func = ModifiedClick
		menu.arg1 = i
		menu.notCheckable = 1
		if not isUsable then
			menu.colorCode = "|cff848484"
		end
		if issummoned then
			menu.colorCode = "|cff00ff00"
		end
		UIDropDownMenu_AddButton(menu)
	end
	
	elseif GetNumCompanions("MOUNT") >= 21 then
	level = level or 1;
	if (level == 1) then
	for i = 1, ceil(GetNumCompanions("MOUNT")/25) do
		menu.text = i
		menu.notCheckable = 1
		menu.hasArrow = true;
		menu.value = {
			["Level1_Key"] = i
		};
	
		UIDropDownMenu_AddButton(menu, level)
	end
		if favmount1index ~= nil then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", favmount1index)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
			menu.text = format('1. %s', favmount1name)
			menu.icon = favmount1icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = favmount1index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isUsable then
				menu.colorCode = "|cff848484"
			end
			if issummoned then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
		if favmount2index ~= nil then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", favmount2index)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
			menu.text = format('2. %s', favmount2name)
			menu.icon = favmount2icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = favmount2index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isUsable then
				menu.colorCode = "|cff848484"
			end
			if issummoned then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
		if favmount3index ~= nil then
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", favmount3index)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
			menu.text = format('3. %s', favmount3name)
			menu.icon = favmount3icon
			menu.colorCode = "|cffffffff"
			menu.func = ModifiedClick
			menu.arg1 = favmount3index
			menu.hasArrow = nil;
			menu.notCheckable = 1
			if not isUsable then
				menu.colorCode = "|cff848484"
			end
			if issummoned then
				menu.colorCode = "|cff00ff00"
			end
			UIDropDownMenu_AddButton(menu, level)
		end
	end
	if (level == 2) then
	 -- getting values of first menu
    local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"];
		
    for i = 1, GetNumCompanions("MOUNT") do
		
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		--firstChar = strupper(strsub(creatureName, 1, 1))

		menu.hasArrow = false;
		menu.notCheckable = true;
		menu.text = creatureName
		menu.icon = icon
		menu.colorCode = "|cffffffff"
		menu.func = ModifiedClick
		menu.arg1 = i
		
		if not isUsable then
			menu.colorCode = "|cff848484"
		end
		if issummoned then
			menu.colorCode = "|cff00ff00"
		end
		
		if i >= 1 and i <= 25 and Level1_Key == 1 then
			UIDropDownMenu_AddButton(menu, level)
			
		elseif i >= 26 and i <= 50 and Level1_Key == 2 then
			UIDropDownMenu_AddButton(menu, level)		
		
		elseif i >= 51 and i <= 75 and Level1_Key == 3 then
			UIDropDownMenu_AddButton(menu, level)
				
		elseif i >= 76 and i <= 100 and Level1_Key == 4 then
			UIDropDownMenu_AddButton(menu, level)
				
		elseif i >= 101 and i <= 125 and Level1_Key == 5 then
			UIDropDownMenu_AddButton(menu, level)
			
		elseif i >= 126 and i <= 150 and Level1_Key == 6 then
			UIDropDownMenu_AddButton(menu, level)
				
		elseif i >= 151 and i <= 175 and Level1_Key == 7 then
			UIDropDownMenu_AddButton(menu, level)
				
		elseif i >= 176 and i <= 200 and Level1_Key == 8 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 201 and i <= 225 and Level1_Key == 9 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 226 and i <= 250 and Level1_Key == 10 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 251 and i <= 275 and Level1_Key == 11 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 276 and i <= 300 and Level1_Key == 12 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 301 and i <= 325 and Level1_Key == 13 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 326 and i <= 350 and Level1_Key == 14 then
			UIDropDownMenu_AddButton(menu, level)
			
		elseif i >= 351 and i <= 375 and Level1_Key == 15 then
			UIDropDownMenu_AddButton(menu, level)
		
		elseif i >= 376 and i <= 400 and Level1_Key == 16 then
			UIDropDownMenu_AddButton(menu, level)	
		end
	
	end
	end
	end

end]]



function parent:PLAYER_LOGIN()
	LDB = LibStub('LibDataBroker-1.1'):NewDataObject('BrokerMounts', {
		icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
		text = "BrokerMounts",
		type = 'data source',
		OnTooltipShow = OnTooltipShow,
		--OnEnter = anchor_OnEnter,
		OnLeave = anchor_OnLeave,
		OnClick = OnClick,
	})
	self:RegisterEvent('SPELL_UPDATE_USABLE')
	self:RegisterEvent('COMPANION_UPDATE')
	self.COMPANION_UPDATE = UpdateDisplay
	self.SPELL_UPDATE_USABLE = UpdateDisplay

	--self.initialize = CreateMenu
	--self.displayMode = 'MENU'
	
	UpdateDisplay()
end

parent:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
parent:RegisterEvent('PLAYER_LOGIN')